/*
 * Copyright (c) 1995 PFU Limited.
 *	author Osamu Satoh, Kazuhisa Shirakami
 */
package teikade.gui;

import teikade.gui.editor.EditData;

public class CodeData {
    EditData data;
    private String original = null;

    /**
     * the constructor
     */
    public CodeData(EditData data) {
	this.data = data;
    }

    public void setEditable(boolean editable) {
	data.setEditable(editable);
    }

    public boolean isEditable() {
	return data.isEditable();
    }

    /**
     * set new code
     */
    public void setCode(String code) {
	data.setText(code);
	original = data.getText();
    }

    /**
     * get code
     */
    public String getCode() {
	return data.getText();
    }

    public String getSelectedCode() {
	return data.getSelectedText();
    }

    /**
     * reset text, set original text once more
     */
    void resetCode() {
	data.setText(original);
    }

    /**
     * replace code
     */
    void replaceCode(String code) {
	data.setText(code);
    }

    /**
     * replace original text
     */
    void replaceOriginal(String code) {
	original = code;
    }

    /**
     * returns whether this code is changed or not
     */
    boolean isChanged() {
	return (data.isEditable() && !data.getText().equals(original));
    }

    public void select(int start, int end) {
	data.select(start, end);
    }

    public int getSelectionStart() {
	return data.getSelectionStart();
    }

    public void requestFocus() {
	data.requestFocus();
    }
}
