/*
 * Copyright (c) 1995 PFU Limited.
 *	author Osamu Satoh, Kazuhisa Shirakami
 */
package teikade.gui;

import java.awt.*;

//import teikade.sys.SystemManager;
import teikade.gui.Replacer;
import teikade.gui.editor.EditData;
import teikade.sys.*;

class ListingReplacer extends Replacer {
    private ListingFrame listingFrame;
    private int index;

    ListingReplacer(ListingFrame lf, EditData ed) {
	super(lf, ed);
	listingFrame = lf;
    }

    protected boolean backward() {
	int selection = listingFrame.selection;
	if (selection < 0) {
	    selection = listingFrame.list.countItems() - 1;
	    try {
		if (!listingFrame.select(selection)) return false;
	    } catch (TeikadeException e) {
		listingFrame.information(e.getMessage());
		return false;
	    }
	    int last = target.getText().length();
	    target.select(last, last);
	}
	while (!super.backward()) {
	    if (--selection < 0) {
		SystemManager.beep();
		return false;
	    }
	    if (listingFrame.itemAt(selection).isSameCode(
					listingFrame.itemAt(selection + 1))) {
		listingFrame.list.selectAndVisible(selection);
	    } else {
		try {
		    if (!listingFrame.select(selection)) return false;
		} catch (TeikadeException e) {
		    listingFrame.information(e.getMessage());
		    return false;
		}
		int last = target.getText().length();
		target.select(last, last);
	    }
	}
	return true;
    }

    protected boolean forward() {
	int selection = listingFrame.selection;
	if (selection < 0) {
	    selection = 0;
	    try {
		if (!listingFrame.select(selection)) return false;
	    } catch (TeikadeException e) {
		listingFrame.information(e.getMessage());
		return false;
	    }
	    target.select(0, 0);
	}
	while (!super.forward()) {
	    if (++selection >= listingFrame.list.countItems()) {
		SystemManager.beep();
		return false;
	    }
	    if (listingFrame.itemAt(selection).isSameCode(
					listingFrame.itemAt(selection - 1))) {
		listingFrame.list.selectAndVisible(selection);
	    } else {
		try {
		    if (!listingFrame.select(selection)) return false;
		} catch (TeikadeException e) {
		    listingFrame.information(e.getMessage());
		    return false;
		}
		target.select(0, 0);
	    }
	}
	return true;
    }
}
