/*
 * Copyright (c) 1995 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.gui.component;

import java.awt.*;
import teikade.sys.SystemManager;
import teikade.sys.TeikadeProperties;
import teikade.sys.UseProperties;

public class DDialog1_1 extends Dialog implements UseProperties {
    private DDialog parent;

    public DDialog1_1(DDialog parent, Frame frame, boolean modal) {
	super(frame, modal);
	this.parent = parent;
    }

    public void updateProperties() {
	Font font = TeikadeProperties.getFont("font.dialog");
	if (font != null && !font.equals(getFont())) {
	    setFont(font);
	}
    }

    public boolean mouseMove(Event ev, int x, int y) {
	if (SystemManager.onSolaris) {
	    Component comp = locate(x, y);
	    Container cont = null;
	    while ((comp instanceof Container) && comp != cont) {
		cont = (Container)comp;
		Point loc = cont.location();
		x -= loc.x;
		y -= loc.y;
		comp = cont.locate(x, y);
	    }
	    if (comp != null) {
		comp.requestFocus();
		return true;
	    }
	}
	return super.mouseMove(ev, x, y);
    }

    public boolean handleEvent(Event event) {
	if (super.handleEvent(event)) return true;
	return parent.handleEvent(event);
    }

    public boolean action(Event event, Object arg) {
	return parent.action(event, arg);
    }
}
