/*
 * Copyright (c) 1996 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.gui.component;

import java.awt.*;
import teikade.sys.TeikadeProperties;
import teikade.sys.UseProperties;

public class DMenuItem extends MenuItem implements UseProperties {
    Object target;

    public DMenuItem(String label) {
	this(label, null);
    }

    public DMenuItem(String label, Object target) {
	super(label);
	this.target = target;
	updateProperties();
    }

    public void updateProperties() {
	Font font = TeikadeProperties.getFont("font.menu");
	if (font != null && !font.equals(getFont())) {
	    setFont(font);
	}
    }

    public Object getTarget() {
	return target;
    }
}
