/*
 * Copyright (c) 1995,1996 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.gui.component;

import java.awt.*;
import teikade.sys.TeikadeProperties;
import teikade.sys.UseProperties;
import teikade.gui.editor.EditField;

public class DTextField extends EditField implements UseProperties {

    public DTextField() {
	super();
	updateProperties();
    }

    public DTextField(int cols) {
	super(cols);
	updateProperties();
    }

    public DTextField(String text) {
	super(text);
	updateProperties();
    }

    public DTextField(String text, int cols) {
	super(text, cols);
	updateProperties();
    }

    public void updateProperties() {
	Font font = TeikadeProperties.getFont("font.list");
	if (font != null && !font.equals(getFont())) {
	    setFont(font);
	}
	Color color = TeikadeProperties.getColor("color.code.foreground");
	if (color != null) setForeground(color);
	color = TeikadeProperties.getColor("color.code.background");
	if (color != null) setBackground(color);
    }

    public void select(int sel) {
	select(sel, sel);
    }

    public void setEditable(boolean editable) {
	if (super.isEditable() != editable) {
	    super.setEditable(editable);	// for flickerless
	}
    }
}
