/*
 * Copyright (c) 1995 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.gui.component;

import java.awt.*;
import teikade.sys.SystemManager;

class DelegateEventFrame extends Frame implements EventHandler {
    private EventDelegater eventDelegater = new EventDelegater(this);

    DelegateEventFrame() {
	super();
    }

    DelegateEventFrame(String title) {
	super(title);
    }

    public final boolean postEvent(Event event) {
	if (eventDelegater == null) {
	    return postEvent0(event);
	} else {
	    return eventDelegater.delegate(event);
	}
    }

    public boolean postEvent0(Event event) {
	return super.postEvent(event);
    }

    public void dispose() {
	eventDelegater.dispose();
	eventDelegater = null;
	if (SystemManager.onWin32) {
	    super.dispose();
	} else {
	    hide();
	    MenuBar menuBar = getMenuBar();
	    if (menuBar != null) remove(menuBar);
	    Component comps[] = getComponents();
	    for (int i = 0; i < comps.length; i++) {
		comps[i].removeNotify();
	    }
	    //super.dispose();	// sometimes hung up on Solaris
	}
    }
}
