/*
 * Copyright (c) 1995 PFU Limited.
 *	author Osamu Satoh
 */
package teikade.gui.dialog;

import java.awt.*;

import teikade.sys.*;
import teikade.lang.JavaLexical;
import teikade.gui.component.*;

public class NewProjectDialog extends TeikadeFileDialog {
    static String PROJECT_AUTO_SPAWN_ON_CREATE =
	"project.autoSpawnOnCreate";
    
    TextField name;
    Checkbox  rebuildCheck;
    Checkbox  spawnCheck;

    String projectName;
    String projectPath;
    boolean  rebuildNow;
    boolean  spawnNow;

    public NewProjectDialog(Frame parent) {
	super(parent, "Add New Project");
    }

    public Component createDisplayItems() {
	Panel labels = new Panel();
	labels.setLayout(new GridLayout(4, 1));
	labels.add(new DLabel("project name:", Label.RIGHT));
	labels.add(new DLabel("project path:", Label.RIGHT));
	labels.add(new DLabel("rebuild database now:", Label.RIGHT));
	labels.add(new DLabel("spawn browser now:", Label.RIGHT));

	Panel values = new Panel();
	values.setLayout(new GridLayout(4, 1));
	values.add(name = new DTextField(30));
	values.add(super.createDisplayItems());
	values.add(rebuildCheck = new DCheckbox(""));
	values.add(spawnCheck = new DCheckbox(""));

	String spawnProperty =
		TeikadeProperties.getString(PROJECT_AUTO_SPAWN_ON_CREATE);
	spawnNow = (spawnProperty == null) || (spawnProperty.equals("true"));
	spawnCheck.setState(spawnNow);

	Panel panel = new Panel();
	panel.setLayout(new BorderLayout());
	panel.add(WEST,   labels);
	panel.add(CENTER, values);

	return panel;
    }

    public String projectName() {
	return projectName;
    }

    public String projectPath() {
	return projectPath;
    }

    public boolean rebuildNow() {
	return rebuildNow;
    }

    public boolean spawnNow() {
	return spawnNow;
    }

    public void actionLeftButton() {
	projectName = name.getText().trim();
	if (projectName.length() == 0) return;
	int illegal = JavaLexical.isIdentifier(projectName);
	if (illegal >= 0) {
	    information("illegal character '" + projectName.charAt(illegal)
					      + "' for project name");
	    return;
	}
	projectPath = getPath().trim();
	if (projectPath.length() == 0) return;
	rebuildNow = rebuildCheck.getState();
	spawnNow = spawnCheck.getState();
	super.actionLeftButton();
    }
}
