/*
 * Copyright (c) 1996 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.gui.editor;

import java.awt.Event;
import teikade.sys.SystemManager;

class SimpleEditKeyHandler extends SimpleViewKeyHandler {

    public boolean withNone(EditData editData, Event event) {
	boolean shift = event.shiftDown();
	if (shift && SystemManager.needWin32TextComponentPatch
	 && event.key > Event.HOME && event.key <= Event.RIGHT) {
	    return false;
	}
	switch (event.key) {
	case '\b':
	    if (editData.cutSelectedText()) return true;
	    if (!shift) {
		editData.backSpace();
	    } else {
		editData.anchor().backwardChar().delete();
	    }
	    return true;
	case '\177':
	    if (SystemManager.needWin32TextComponentPatch && shift) {
		return false;
	    }
	    if (editData.cutSelectedText()) return true;
	    editData.anchor().forwardChar().delete();
	    return true;
	case '\t':
	    editData.tab(shift);
	    return true;
	case '\n':
	    if (!shift) {
		editData.returnAndIndent();
	    } else {
		editData.insert("\n");
	    }
	    return true;
	case 1025:
	    if (SystemManager.needWin32TextComponentPatch && shift) {
		return false;
	    }
	    return false;
	}
	if (super.withNone(editData, event)) {
	    return true;
	}
	char key = (char)event.key;
	if ((int)key == event.key && key >= ' ' && Character.isDefined(key)) {
	    editData.insert(""+key);
	    return true;
	}
	return false;
    }

    public boolean withCtrl(EditData editData, Event event) {
	switch (event.key) {
	case 's': case '\023':
	    editData.setStatus("Accept and Syncing... ");
	    Thread.yield();
	    if (editData.notifyObserver(EditDataObserver.ACCEPT)
	     && editData.notifyObserver(EditDataObserver.SYNC)) {
		editData.setStatus("Accept and Syncing... done.");
	    } else {
		editData.setStatus("Accept and Syncing... aborted.");
	    }
	    return true;
	}
	return super.withCtrl(editData, event);
    }
}
