package teikade.gui.menu;

import java.awt.Event;
import java.awt.MenuContainer;
import java.awt.MenuComponent;
import teikade.gui.Browser;
import teikade.gui.component.DMenu;
import teikade.gui.component.DCheckboxMenuItem;

public class MethodOrderMenu extends DMenu {
    private MethodOrderMenuItem items[] = {
	new MethodOrderMenuItem("no sort", Browser.NO_SORT),
	new MethodOrderMenuItem("sort by method name", Browser.SORT_BY_METHOD_NAME),
	new MethodOrderMenuItem("sort by return type", Browser.SORT_BY_RETURN_TYPE)
    };

    public MethodOrderMenu(String label) {
	super(label);
	for (int i = 0; i < items.length; i++) {
	    add(items[i]);
	}
    }

    public void update(int order) {
	for (int i = 0; i < items.length; i++) {
	    if (i != order) items[i].setState(false);
	}
	items[order].setState(true);
    }

    public boolean postEvent(Event event) {
	if (event.target instanceof MethodOrderMenuItem) {
	    MenuContainer parent = getParent();
	    while (!(parent instanceof Browser)) {
		if (!(parent instanceof MenuComponent)) return super.postEvent(event);
		parent = ((MenuComponent)parent).getParent();
	    }
	    MethodOrderMenuItem item = (MethodOrderMenuItem)event.target;
	    for (int i = 0; i < items.length; i++) {
		if (items[i] != item) items[i].setState(false);
	    }
	    item.setState(true);
	    ((Browser)parent).setMethodOrder(item.getValue());
	    return true;
	}
	return super.postEvent(event);
    }
}

class MethodOrderMenuItem extends DCheckboxMenuItem {
    private int value;

    MethodOrderMenuItem(String label, int value) {
	super(label);
	this.value = value;
    }

    int getValue() {
	return value;
    }
}
