/*
 * Copyright (c) 1996 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.lang;

public class Terms extends java.awt.Frame {
    public static final String javaIoExceptions[] = {
	"java.io",
	"EOFException",
	"FileNotFoundException",
	"IOException",
	"InterruptedIOException",
    };
    public static final String javaNetExceptions[] = {
	"java.net",
	"UTFDataFormatException",
	"MalformedURLException",
	"ProtocolException",
	"SocketException",
	"UnknownHostException",
	"UnknownServiceException",
    };
    public static final String javaLangExceptions[] = {
	"java.lang",
	"Exception",
	"Error",
	"Throwable"
    };
    public static final Object exceptions[] = {
	"exceptions",
	javaIoExceptions,
	"java.io.EOFException",
	"java.io.FileNotFoundException",
	"java.io.IOException",
	"java.io.InterruptedIOException",
	"java.io.UTFDataFormatException",
	javaNetExceptions,
	"java.net.MalformedURLException",
	"java.net.ProtocolException",
	"java.net.SocketException",
	"java.net.UnknownHostException",
	"java.net.UnknownServiceException",
	javaLangExceptions,
    };
    public static final Object terms[] = {
	"set terms",
	exceptions,
    };
    java.awt.TextField textField;

    public static java.awt.Menu termsMenu(Object terms[]) {
	java.awt.Menu menu = new java.awt.Menu((String)terms[0]);
	for (int i = 1; i < terms.length; i++) {
	    Object term = terms[i];
	    if (term instanceof String) {
		menu.add((String)term);
	    } else {
		menu.add(termsMenu((Object[])term));
	    }
	}
	return menu;
    }

    Terms() {
	java.awt.Menu methodMenu = new java.awt.Menu("Method");
	methodMenu.add("new constractor");
	methodMenu.add("new method");
	methodMenu.add("set prototype");
	methodMenu.add(termsMenu(terms));
	java.awt.MenuBar menuBar = new java.awt.MenuBar();
	menuBar.add(methodMenu);
	setMenuBar(menuBar);
	add("Center", textField = new java.awt.TextField(30));
	pack();
    }

    public boolean handleEvent(java.awt.Event ev) {
	if (ev.id == java.awt.Event.WINDOW_DESTROY) {
	    System.exit(0);
	}
	return super.handleEvent(ev);
    }

    public boolean action(java.awt.Event ev, Object arg) {
	if (ev.target instanceof java.awt.MenuItem) {
	    textField.setText((String)arg);
	    return true;
	}
	return super.action(ev, arg);
    }

    public static void main(String args[]) {
	new Terms().show();
    }
}
