/*
 * Copyright (c) 1999 PFU Limited.
 *	author Osamu Satoh
 */
package teikade.sys;

/**
 * An exception which indicates exception occurence while plugin command
 * execution.
 */
public class PluginException extends Exception {
    private Exception realException;

    /**
     * Constructs an exception with message describes what happened.
     */
    public PluginException(String message) {
	super(message);
    }

    /**
     * Constructs an exception with no detailed message.
     */
    public PluginException() {
	super();
    }

    /**
     * Constructs an exception with message and exception internally caught.
     */
    public PluginException(String message, Exception realException) {
	super(message);
	this.realException = realException;
    }

    /**
     * Constructs an exception with exception internally caught.
     */
    public PluginException(Exception realException) {
	this.realException = realException;
    }

    /**
     * Gets internally caught exception.
     */
    public Exception getRealException() {
	return realException;
    }
}
