/*
 * Copyright (c) 1997 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.util;

import teikade.sys.TeikadeFile;
import java.io.*;

public class CodeConverter1_0 implements CodeConverterPeer {

    public String toString(byte bytes[], int offset, int count) {
	return new String(bytes, 0, offset, count);
    }

    public String toString(TeikadeFile file)
    throws FileNotFoundException, IOException {
	InputStream is = file.getInputStream();
	try {
	    byte buf[] = new byte[is.available()];
	    is.read(buf);
	    return new String(buf, 0);
	} finally {
	    is.close();
	}
    }

    public String readLine(DataInputStream dis) throws IOException {
	return dis.readLine();
    }

    public byte toBytes(String string)[] {
	byte buf[] = new byte[string.length()];
	string.getBytes(0, buf.length, buf, 0);
	return buf;
    }
}
