/*
 * Copyright (c) 1998 PFU Limited.
 *      author Kazuhisa Shirakami
 */
package teikade.util;

import teikade.sys.SystemManager;
import teikade.sys.CodePath;

public class CompileJDK extends CompileExternal {

    public static boolean canExecute() {
	return getJDKCommandName() != null;
    }

    public static String getJDKCommandName() {
	return CommandExternal.getJDKCommandName("javac");
    }

    public String getJDKCommandOptions() {
	return addJDKCommandOptions(new StringBuffer()).toString();
    }

    public StringBuffer addJDKCommandOptions(StringBuffer options) {
	options.append("-d %");
	options.append(getClassPathPropertyName());
	options.append("% -classpath %");
	options.append(getClassPathPropertyName());
	options.append("%%path.separator%%java.class.path%");
	if (SystemManager.onJDK1_1) {
	    options.append(" -deprecation");
	}
	return options;
    }

    public CompileJDK() {
    }

    protected String getDefaultCommandName() {
	return getJDKCommandName();
    }

    protected String getDefaultCommandOptions() {
	return getJDKCommandOptions();
    }

    protected CommandExternalListener makeCommandExternalListener() {
	return new CompileJDKResultBuilder(this);
    }
}
