/*
 * Copyright (c) 1998 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.util;

import teikade.sys.SystemManager;
import teikade.sys.TeikadeProperties;

public class TextUtil {
    private static TextUtil instance;

    public static TextUtil getInstance() {
	if (instance == null) {
	    String className = TeikadeProperties.getString("instance.TextUtil.class");
	    if (className != null) {
		try {
		    instance = (TextUtil)Class.forName(className).newInstance();
		} catch (Exception e) {
		}
	    }
	    if (instance == null) {
		instance = new TextUtil();
	    }
	}
	return instance;
    }

    public int column(String text, int tabWidth) {
	int column = 0;
	int len = text.length();
	for (int i = 0; i < len; i++) {
	    char c = text.charAt(i);
	    if (c == '\t') {
		column += tabWidth;
		column -= column % tabWidth;
	    } else if (isDoubleWidth(text.charAt(i))) {
		column += 2;
	    } else {
		column++;
	    }
	}
	return column;
    }

    public boolean isDoubleWidth(char c) {
	if (c < 0x80) {
	    return false;
	} else if (c >= 0x2010) {
	    if (c <= 0x9fff
	     || c >= 0xf900 && c <= 0xfdff
	     || c >= 0xff01 && c <= 0xff5e
	     || c == 0xffe0 && c <= 0xffe5) {
		return true;
	    }
	} else if (c >= 0x0391) {
	     if (c <= 0x03c9
	     || c == 0x0401
	     || c >= 0x0410 && c <= 0x044f
	     || c == 0x0451) {
		return true;
	    }
	} else if (SystemManager.onJDK1_1) {
	    if (c == 0x00a2 || c == 0x00a3 || c == 0x00a7
	     || c == 0x00a8 || c == 0x00ac || c == 0x00b0
	     || c == 0x00b1 || c == 0x00b4 || c == 0x00b6
	     || c == 0x00d7 || c == 0x00f7) {
		return true;
	    }
	}
	return false;
    }
}
